import 'package:firebase_auth/firebase_auth.dart';
import 'package:google_sign_in/google_sign_in.dart';

class Auth {
  final FirebaseAuth firebaseAuth = FirebaseAuth.instance;
  //final GoogleSignIn googleSignIn = GoogleSignIn();
  Future<void> signInEmailPassword(
      {required String email, required String passwd}) async {
    await firebaseAuth.signInWithEmailAndPassword(
        email: email, password: passwd);
  }

  static getUserId() {
    FirebaseAuth firebaseAuth = FirebaseAuth.instance;
    return firebaseAuth.currentUser?.uid;
  }

  static Future<User?> signInWithGoogle() async {
    final googleAccount = await GoogleSignIn().signIn();
    final googleAuth = await googleAccount?.authentication;

    final credential = GoogleAuthProvider.credential(
        accessToken: googleAuth?.accessToken, idToken: googleAuth?.idToken);
    final userCredential = await FirebaseAuth.instance.signInWithCredential(
      credential,
    );
    return userCredential.user;

    /*  
    try {
      final GoogleSignInAccount googleUser = await googleSignIn.signIn();
      if (googleUser == null) {
        print('Google user is null');
        return null;
      }
      final GoogleSignInAuthentication googleAuth =
          await googleUser.authentication;
      print(
          'GoogleAuth: accessToken: ${googleAuth.accessToken}, idToken: ${googleAuth.idToken}');

      final AuthCredential credential = GoogleAuthProvider.credential(
        accessToken: googleAuth.accessToken,
        idToken: googleAuth.idToken,
      );

      final UserCredential userCredential =
          await FirebaseAuth.instance.signInWithCredential(credential);
      print('UserCredential: ${userCredential.user}');
      return userCredential.user;
    } catch (e) {
      print('Error signing in with Google: $e');
      return null;
    }*/
  }

  Future<void> createUser({
    required String email,
    required String passwd,
  }) async {
    UserCredential userCredential =
        await firebaseAuth.createUserWithEmailAndPassword(
      email: email,
      password: passwd,
    );
    User? user = userCredential.user;
    if (user != null && !user.emailVerified) {
      await user.sendEmailVerification();
    }
  }

  Future<void> signOut() async {
    await firebaseAuth.signOut();
  }
}
