import 'package:flutter/material.dart';
import 'package:weather_station/pages/addDevice.dart';

Color background = const Color(0xff06B2A7);

class AddInstructions extends StatefulWidget {
  const AddInstructions({super.key});

  @override
  _AddInstructionsState createState() => _AddInstructionsState();
}

class _AddInstructionsState extends State<AddInstructions> {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    double menuSpace = 10;
    return Scaffold(
      appBar: AppBar(
        iconTheme: const IconThemeData(color: Colors.white),
        backgroundColor: background,
        title: const Text(
          "Instructions",
          style: TextStyle(
            color: Color(0xffF6F6F6),
          ),
        ),
      ),
      body: Center(
        child: SizedBox(
          width: 300,
          child: Column(
            mainAxisAlignment: MainAxisAlignment.center,
            children: [
              Text(
                "1. Open settings",
                textAlign: TextAlign.center,
              ),
              Text(
                "2. Connect to the weather station wifi",
                textAlign: TextAlign.center,
              ),
              Text(
                "3. Enter credentials of your wiif",
                textAlign: TextAlign.center,
              ),
              Text(
                "4. Press connect",
                textAlign: TextAlign.center,
              ),
              Padding(
                padding: const EdgeInsets.only(top: 50),
                child: SizedBox(
                  width: 150,
                  height: 50,
                  child: ElevatedButton(
                    onPressed: () {
                      Navigator.push(
                        context,
                        MaterialPageRoute(
                            builder: (context) => AddDevicePage()),
                      );
                    },
                    child: Text(
                      'Next',
                      style: TextStyle(color: background),
                    ),
                  ),
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }
}
