import 'package:flutter/material.dart';
import 'package:weather_station/pages/forgot.dart';
import 'package:weather_station/pages/home.dart';
import 'package:weather_station/pages/registration.dart';
import 'package:firebase_auth/firebase_auth.dart';
import 'package:weather_station/auth.dart';
import 'package:fluttertoast/fluttertoast.dart';

String email = "";
String passwd = "";
String? errorMsg = "";
bool isLogin = true;
User? user = FirebaseAuth.instance.currentUser;
Color background = const Color(0xff06B2A7);
Color passwordColor = const Color(0xff121212);
Color emailColor = const Color(0xff121212);

//TODO verif email

class LoginClass extends StatefulWidget {
  const LoginClass({super.key});
  @override
  _LoginClassState createState() => _LoginClassState();
}

class _LoginClassState extends State<LoginClass> {
  final textController1 = TextEditingController(text: email);
  final textController2 = TextEditingController();

  @override
  void dispose() {
    textController1.dispose();
    textController2.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      resizeToAvoidBottomInset: false,
      body: Container(
        color: background,
        child: Column(
          children: [
            Padding(
              padding: const EdgeInsets.only(top: 70),
              child: Center(
                child: Column(
                  mainAxisAlignment: MainAxisAlignment.start,
                  children: [
                    Image.asset('assets/icons/logo.png'),
                    Padding(
                      padding:
                          const EdgeInsets.only(top: 30, right: 50, left: 50),
                      child: TextField(
                        controller: textController1,
                        cursorColor: const Color(0xff121212),
                        decoration: InputDecoration(
                          filled: true,
                          fillColor: const Color(0xffF6F6F6),
                          border: OutlineInputBorder(
                            borderRadius: BorderRadius.circular(10),
                            borderSide: BorderSide(color: emailColor),
                          ),
                          enabledBorder: OutlineInputBorder(
                            borderRadius: BorderRadius.circular(10),
                            borderSide: BorderSide(color: emailColor),
                          ),
                          focusedBorder: OutlineInputBorder(
                            borderRadius: BorderRadius.circular(10),
                            borderSide:
                                BorderSide(color: emailColor, width: 2.0),
                          ),
                          errorBorder: OutlineInputBorder(
                            borderRadius: BorderRadius.circular(10),
                            borderSide: BorderSide(color: emailColor),
                          ),
                          labelText: "E-mail",
                          labelStyle: TextStyle(color: emailColor),
                        ),
                      ),
                    ),
                    Padding(
                      padding:
                          const EdgeInsets.only(top: 20, right: 50, left: 50),
                      child: TextField(
                        controller: textController2,
                        cursorColor: const Color(0xff121212),
                        obscureText: true,
                        enableSuggestions: false,
                        autocorrect: false,
                        decoration: InputDecoration(
                          filled: true,
                          fillColor: const Color(0xffF6F6F6),
                          border: OutlineInputBorder(
                            borderRadius: BorderRadius.circular(10),
                            borderSide: BorderSide(color: passwordColor),
                          ),
                          enabledBorder: OutlineInputBorder(
                            borderRadius: BorderRadius.circular(10),
                            borderSide: BorderSide(color: passwordColor),
                          ),
                          focusedBorder: OutlineInputBorder(
                            borderRadius: BorderRadius.circular(10),
                            borderSide:
                                BorderSide(color: passwordColor, width: 2.0),
                          ),
                          errorBorder: OutlineInputBorder(
                            borderRadius: BorderRadius.circular(10),
                            borderSide: BorderSide(color: passwordColor),
                          ),
                          labelText: "Password",
                          labelStyle: TextStyle(color: passwordColor),
                        ),
                      ),
                    ),
                    Padding(
                      padding: const EdgeInsets.all(30),
                      child: GestureDetector(
                        onTap: () async {
                          setState(() {
                            email = textController1.text;
                            passwd = textController2.text;
                          });

                          if (email.contains('@') &&
                              email.contains('.') &&
                              passwd.length >= 6) {
                            try {
                              await Auth().signInEmailPassword(
                                  email: email, passwd: passwd);
                              setState(() {
                                emailColor = const Color(0xff121212);
                                passwordColor = const Color(0xff121212);
                              });

                              User? user = FirebaseAuth.instance.currentUser;

                              if (user != null && user.emailVerified) {
                                isLogin = true;
                                Navigator.push(
                                  context,
                                  MaterialPageRoute(
                                      builder: (context) => HomePage()),
                                );
                              } else {
                                Fluttertoast.showToast(
                                  msg: "You don't have your email verified.",
                                );
                              }
                            } on FirebaseAuthException catch (e) {
                              Fluttertoast.showToast(
                                msg: "Error while logging in",
                                toastLength: Toast.LENGTH_SHORT,
                                gravity: ToastGravity.BOTTOM,
                                backgroundColor: Colors.white,
                                textColor: Colors.black,
                              );
                              print("Login problem: ${e.message}");
                              errorMsg = e.message;
                            }
                          } else {
                            setState(() {
                              if (!email.contains('@') ||
                                  !email.contains('.')) {
                                emailColor = Colors.red;
                              } else {
                                emailColor = const Color(0xff121212);
                              }
                              if (passwd.length < 6) {
                                passwordColor = Colors.red;
                              } else {
                                passwordColor = const Color(0xff121212);
                              }
                            });
                            Fluttertoast.showToast(
                              msg: 'Wrong format of credentials',
                              toastLength: Toast.LENGTH_SHORT,
                              gravity: ToastGravity.BOTTOM,
                              backgroundColor:
                                  const Color.fromARGB(255, 255, 255, 255),
                              textColor: const Color.fromARGB(255, 0, 0, 0),
                            );
                          }
                        },
                        child: Container(
                          width: 250,
                          height: 60,
                          decoration: BoxDecoration(
                            border: Border.all(color: Colors.black),
                            borderRadius: BorderRadius.circular(20),
                            color: const Color(0xffF6F6F6),
                          ),
                          child: const Center(
                            child: Text("Login"),
                          ),
                        ),
                      ),
                    ),
                    Padding(
                      padding: const EdgeInsets.all(10),
                      child: GestureDetector(
                        onTap: () async {
                          try {
                            final user = await Auth.signInWithGoogle();
                            if (user != null && mounted) {
                              Navigator.pushReplacement(
                                context,
                                MaterialPageRoute(
                                    builder: (context) => HomePage()),
                              );
                            } else {
                              print("User null");
                            }
                          } on FirebaseAuthException catch (e) {
                            Fluttertoast.showToast(
                              msg: "Error while logging in",
                              toastLength: Toast.LENGTH_SHORT,
                              gravity: ToastGravity.BOTTOM,
                              backgroundColor: Colors.white,
                              textColor: Colors.black,
                            );
                            print("Login problem: ${e.message}");
                            errorMsg = e.message;
                          } catch (e) {
                            print("Login problem: $e");
                          }
                        },
                        child: Container(
                          width: 250,
                          height: 60,
                          decoration: BoxDecoration(
                            border: Border.all(color: Colors.black),
                            borderRadius: BorderRadius.circular(20),
                            color: const Color(0xffF6F6F6),
                          ),
                          child: Row(
                            mainAxisAlignment: MainAxisAlignment.center,
                            children: [
                              Image.asset(
                                'assets/icons/devicon_google.png',
                                width: 32,
                                height: 32,
                              ),
                              const Padding(
                                padding: EdgeInsets.only(left: 20),
                                child: Text("Login using Gmail"),
                              ),
                            ],
                          ),
                        ),
                      ),
                    ),
                  ],
                ),
              ),
            ),
            Padding(
              padding: const EdgeInsets.only(top: 40),
              child: GestureDetector(
                child: const Text(
                  "Register",
                  style: TextStyle(color: Color(0xffF6F6F6)),
                ),
                onTap: () {
                  Navigator.push(
                      context,
                      MaterialPageRoute(
                        builder: (context) => RegisterClass(),
                      ));
                },
              ),
            ),
            //pridane vo vlaku testnut doma
            GestureDetector(
              onTap: () {
                Navigator.push(
                    context,
                    MaterialPageRoute(
                        builder: (context) => ForgotPasswordPage()));
              },
              child: const Padding(
                padding: EdgeInsets.only(top: 20),
                child: Text(
                  "Forgot password",
                  style: TextStyle(color: Color(0xffF6F6F6)),
                ),
              ),
            )
          ],
        ),
      ),
    );
  }
}
