import 'package:flutter/material.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:weather_station/pages/home.dart';
import 'package:firebase_auth/firebase_auth.dart';
import 'package:weather_station/auth.dart';
import 'package:weather_station/auth.dart';
import 'package:weather_station/pages/login.dart';
import 'package:weather_station/pages/verify.dart';

String email = "";
String nickname = "";
String passwd = "";
String repeatPasswd = "";

Color background = const Color(0xff06B2A7);
Color passwordColor = const Color(0xff121212);
Color repeatPasswordColor = const Color(0xff121212);
Color emailColor = const Color(0xff121212);
Color nicknameColor = const Color(0xff121212);

class RegisterClass extends StatefulWidget {
  const RegisterClass({super.key});
  @override
  _RegisterClassState createState() => _RegisterClassState();
}

final textController1 = TextEditingController(text: email);
final textController2 = TextEditingController(text: nickname);
final textController3 = TextEditingController(text: passwd);
final textController4 = TextEditingController(text: repeatPasswd);

class _RegisterClassState extends State<RegisterClass> {
/*
  @override
  void dispose() {
    textController1.dispose();
    super.dispose();
  }*/

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      resizeToAvoidBottomInset: false,
      body: Container(
        color: background,
        child: Column(
          children: [
            Padding(
              padding: const EdgeInsets.only(top: 100),
              child: Center(
                child: Column(
                  mainAxisAlignment: MainAxisAlignment.start,
                  children: [
                    const Padding(
                      padding: EdgeInsets.only(top: 10),
                      child: Text(
                        "Register",
                        style: TextStyle(fontSize: 50, color: Colors.white),
                      ),
                    ),
                    Padding(
                      padding:
                          const EdgeInsets.only(top: 20, right: 50, left: 50),
                      child: TextField(
                        controller: textController1,
                        cursorColor: const Color(0xff121212),
                        decoration: InputDecoration(
                          filled: true,
                          fillColor: const Color(0xffF6F6F6),
                          enabledBorder: OutlineInputBorder(
                            borderRadius: BorderRadius.circular(10),
                            borderSide: BorderSide(color: emailColor),
                          ),
                          labelText: "E-mail",
                          focusedBorder: OutlineInputBorder(
                            borderSide:
                                BorderSide(color: emailColor, width: 2.0),
                          ),
                          labelStyle: TextStyle(color: emailColor),
                        ),
                      ),
                    ),
                    Padding(
                      padding:
                          const EdgeInsets.only(top: 20, right: 50, left: 50),
                      child: TextField(
                        controller: textController2,
                        cursorColor: const Color(0xff121212),
                        decoration: InputDecoration(
                          filled: true,
                          fillColor: const Color(0xffF6F6F6),
                          enabledBorder: OutlineInputBorder(
                            borderRadius: BorderRadius.circular(10),
                            borderSide: BorderSide(color: nicknameColor),
                          ),
                          labelText: "Nickname",
                          focusedBorder: OutlineInputBorder(
                            borderSide:
                                BorderSide(color: nicknameColor, width: 2.0),
                          ),
                          labelStyle: TextStyle(color: nicknameColor),
                        ),
                      ),
                    ),
                    Padding(
                      padding:
                          const EdgeInsets.only(top: 30, right: 50, left: 50),
                      child: TextField(
                        controller: textController3,
                        cursorColor: const Color(0xff121212),
                        obscureText: true,
                        enableSuggestions: false,
                        autocorrect: false,
                        decoration: InputDecoration(
                            filled: true,
                            fillColor: const Color(0xffF6F6F6),
                            enabledBorder: OutlineInputBorder(
                              borderRadius: BorderRadius.circular(10),
                              borderSide: BorderSide(color: passwordColor),
                            ),
                            labelText: "Password",
                            focusedBorder: OutlineInputBorder(
                              borderSide:
                                  BorderSide(color: passwordColor, width: 2.0),
                            ),
                            labelStyle: TextStyle(color: passwordColor)),
                      ),
                    ),
                    Padding(
                      padding:
                          const EdgeInsets.only(top: 20, right: 50, left: 50),
                      child: TextField(
                        controller: textController4,
                        cursorColor: repeatPasswordColor,
                        obscureText: true,
                        enableSuggestions: false,
                        autocorrect: false,
                        decoration: InputDecoration(
                          filled: true,
                          fillColor: const Color(0xffF6F6F6),
                          enabledBorder: OutlineInputBorder(
                            borderRadius: BorderRadius.circular(10),
                            borderSide: BorderSide(color: repeatPasswordColor),
                          ),
                          focusedBorder: OutlineInputBorder(
                            borderSide: BorderSide(
                                color: repeatPasswordColor, width: 2.0),
                          ),
                          labelText: "Repeat password",
                          labelStyle: TextStyle(color: repeatPasswordColor),
                        ),
                      ),
                    ),
                    Padding(
                      padding: const EdgeInsets.all(30),
                      child: GestureDetector(
                        onTap: () async {
                          setState(() {
                            email = textController1.text;
                            nickname = textController2.text;
                            passwd = textController3.text;
                            repeatPasswd = textController4.text;
                          });
                          showDialog(
                            context: context,
                            builder: (context) {
                              //toto sa nevypne kym nestlacim zas register
                              return Center(child: CircularProgressIndicator());
                            },
                          );
                          try {
                            bool allValid = true;
                            bool isPasswordValid = true;
                            if (email.contains('@') &&
                                email.contains('.') &&
                                email.length > 6) {
                              emailColor = const Color(0xff121212);
                            } else {
                              print("Email RED");
                              emailColor = Colors.red;
                              allValid = false;
                            }

                            if (nickname.length > 2) {
                              nicknameColor = const Color(0xff121212);
                            } else {
                              print("NICKNAME RED");
                              nicknameColor = Colors.red;
                              allValid = false;
                            }

                            if (passwd.length >= 6) {
                              passwordColor = const Color(0xff121212);
                            } else {
                              print("PASSWD RED");
                              isPasswordValid = false;
                              passwordColor = Colors.red;
                              allValid = false;
                            }

                            if (passwd == repeatPasswd &&
                                isPasswordValid != false) {
                              repeatPasswordColor = const Color(0xff121212);
                            } else {
                              print("Repeat RED");
                              repeatPasswordColor = Colors.red;
                              allValid = false;
                            }

                            if (allValid) {
                              await Auth().createUser(
                                email: email,
                                passwd: passwd,
                              );
                              Navigator.of(context).pop();
                              Fluttertoast.showToast(
                                msg:
                                    "Registering has been successful, verify your email",
                              );
                              Navigator.pushReplacement(
                                  context,
                                  MaterialPageRoute(
                                      builder: (context) => LoginClass()));
                            }
                          } on FirebaseAuthException catch (e) {
                            if (e.code == 'email-already-in-use') {
                              Navigator.of(context).pop();
                              Fluttertoast.showToast(
                                msg:
                                    "The email address is already in use by another account.",
                              );
                            } else {
                              Navigator.of(context).pop();
                              Fluttertoast.showToast(
                                msg: "Login problem: ${e.message}",
                              );
                            }
                          }
                        },
                        child: Container(
                          width: 250,
                          height: 60,
                          decoration: BoxDecoration(
                            border: Border.all(color: Colors.black),
                            borderRadius: BorderRadius.circular(20),
                            color: const Color(0xffF6F6F6),
                          ),
                          child: const Center(
                            child: Text("Register"),
                          ),
                        ),
                      ),
                    ),
                    Padding(
                      padding: const EdgeInsets.only(top: 30),
                      child: GestureDetector(
                        child: const Text(
                          "Login",
                          style: TextStyle(color: Colors.white),
                        ),
                        onTap: () {
                          Navigator.push(
                              context,
                              MaterialPageRoute(
                                  builder: (context) => LoginClass()));
                        },
                      ),
                    )
                  ],
                ),
              ),
            ),
            GestureDetector(
              child: Padding(
                padding: EdgeInsets.only(top: 20),
                child: Text(
                  "Verify Email",
                  style: TextStyle(color: Colors.white),
                ),
              ),
              onTap: () {
                Navigator.push(context,
                    MaterialPageRoute(builder: (context) => VerifyEmailPage()));
              },
            )
          ],
        ),
      ),
    );
  }
}
