import 'package:flutter/material.dart';
import 'package:weather_station/pages/login.dart';
import 'package:weather_station/pages/home.dart';
import 'package:weather_station/pages/addDevice.dart';
import 'package:firebase_auth/firebase_auth.dart';
import 'package:weather_station/auth.dart';
import 'package:weather_station/pages/settings.dart';
import 'package:weather_station/widgets/drawer.dart';

class drawer extends StatelessWidget {
  const drawer({super.key});

  @override
  Widget build(BuildContext context) {
    double menuSpace = 10;
    Color background = const Color(0xff06B2A7);
    return Drawer(
      width: 280,
      backgroundColor: background,
      child: Container(
        child: Padding(
          padding: const EdgeInsets.only(top: 40),
          child: Column(
            children: [
              ListTile(
                leading: const Icon(
                  Icons.home,
                  color: Color(0xffFFFFFF),
                ),
                textColor: const Color(0xffF6F6F6),
                title: const Text("Home"),
                onTap: () {
                  Navigator.push(
                    context,
                    MaterialPageRoute(builder: (context) => HomePage()),
                  );
                },
              ),
              SizedBox(height: menuSpace),
              const ListTile(
                leading: Icon(
                  Icons.map,
                  color: Color(0xffFFFFFF),
                ),
                textColor: Color(0xffF6F6F6),
                title: Text("Map (will be added)"),
              ),
              SizedBox(height: menuSpace),
              ListTile(
                leading: Icon(
                  Icons.settings,
                  color: Color(0xffFFFFFF),
                ),
                textColor: Color(0xffF6F6F6),
                title: Text("Settings"),
                onTap: () {
                  signOut();
                  Navigator.push(context,
                      MaterialPageRoute(builder: (context) => SettingsClass()));
                },
              ),
              const Spacer(),
              Padding(
                padding: const EdgeInsets.only(bottom: 20),
                child: ListTile(
                  leading: const Icon(
                    Icons.logout,
                    color: Color(0xffFFFFFF),
                  ),
                  textColor: const Color(0xffF6F6F6),
                  title: const Text("Log out"),
                  onTap: () {
                    signOut();
                    Navigator.push(context,
                        MaterialPageRoute(builder: (context) => LoginClass()));
                  },
                ),
              )
            ],
          ),
        ),
      ),
    );
  }

  Future<void> signOut() async {
    await Auth().signOut();
  }
}
