import Header from './../components/header/Header'

const Home = () => {
    return (
		<>
			<Header />
			<main className="section">
				<div className="container">
					<ul className="content-list">

						<li className="content-list__item">
							<h2 className="title-2">Who are <span className="home-gradient">we</span> ?</h2>
							<p>
							We are a dynamic, innovative team dedicated to revolutionizing the way we track weather and manage meteorological stations. 
							Our approach is modern, user-friendly, and built on cutting-edge technology, offering a new perspective on weather monitoring. 
							With our solution, individuals and organizations can effortlessly track, analyze, and control their meteorological data in real-time, ensuring accurate and reliable information at their fingertips. 
							We are here to simplify weather tracking, empower users, and provide them with the tools they need to make informed decisions based on precise weather insights.
							</p>
						</li>

						<li className="content-list__item">
							<h2 className="title-2">What is our <span className="home-gradient">product</span> ?</h2>
							<p>
							Our product is a state-of-the-art weather station designed to measure key environmental factors such as temperature, humidity, air pressure, and air quality right at your home. 
							This data is collected in real-time and can be shared with others on an interactive map, allowing you to not only monitor your personal environment but also contribute to a broader community of weather enthusiasts. 
							Whether youre tracking the conditions at home or sharing insights with others, our weather station offers an intuitive and powerful way to stay connected to the world around you.
							</p>
						</li>

						<li className="content-list__item">

							<h2 className="title-2">What are we <span className="home-gradient">planning</span> ?</h2>
							<p>
								We are constantly working to enhance and expand the capabilities of our weather station. Our upcoming plans include:
							</p>
							<ul className = "content-list-ul">
								<li>UV Sensor: To measure ultraviolet radiation, helping users monitor sun exposure.</li>
								<li>Wind Sensor: We are exploring options to measure either wind speed or direction, or both, to provide more comprehensive weather data.</li>
								<li>Manual Integration with Solar Power: We plan to incorporate manual connections alongside solar panels to make the station more energy-efficient and autonomous.</li>
								<li>Predictions: By utilizing an API, we aim to provide predictive weather insights, offering forecasts based on real-time data.</li>
								<li>Display: A user-friendly display will be added for easy access to all weather data, giving users an immediate overview of the current conditions.</li>
								<li>Solar Controller: A solar controller will be introduced to optimize the use of solar energy for the weather station.</li>
								<li>Solar Panel: We will integrate a solar panel to ensure that the weather station can operate sustainably without relying on traditional power sources.</li>
							</ul>
							<p>
								These features will make our product even more powerful, versatile, and eco-friendly, improving both its performance and user experience.
							</p>

						</li>



					</ul>
				</div>
			</main>
		</>
	);
}

export default Home;