import React from "react";
import Map, { Marker } from "react-map-gl";

const MAPBOX_TOKEN = "pk.eyJ1IjoiYXBrYXN2IiwiYSI6ImNtNXVyY3Y2NjE0czkya3F1aGh5aDdzMGIifQ.fvpNPEtgOLA6btg1BfQXFg";

const mapStyle = {
  width: "100%",
  height: "100%"
};

const center = {
  lat: 48.7168,  
  lng: 21.2611
};

const markerPosition = {
  lat: 48.6880,  
  lng: 21.2872
};

const MapComponent = () => {
  return (
    <main className="section-map">
      <Map
        initialViewState={{
          latitude: center.lat,
          longitude: center.lng,
          zoom: 15
        }}
        style={mapStyle}
        mapStyle="mapbox://styles/mapbox/streets-v11"
        mapboxAccessToken={MAPBOX_TOKEN}
      >
        <Marker
          latitude={markerPosition.lat}
          longitude={markerPosition.lng}
          anchor="bottom"
        >
          <img src="https://docs.mapbox.com/help/demos/custom-markers-gl-js/mapbox-icon.png" alt="Marker" />
        </Marker>
      </Map>
    </main>
  );
};

export default MapComponent;
